diff --git a/bwb_elx.c b/bwb_elx.c
index a35fd92..f9f91b0 100644
--- a/bwb_elx.c
+++ b/bwb_elx.c
@@ -23,6 +23,14 @@
 
 ****************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*                                                               */
+/* Those additionally marked with "DD" were at the suggestion of */
+/* Dale DePriest (daled@cadence.com).                            */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <ctype.h>
 #include <math.h>
@@ -193,7 +201,8 @@ exp_strconst( expression )
 
    /* read the string up until the next double quotation mark */
 
-   while( expression[ e_pos ] != '\"' )
+   /* While yer at it, check for a null terminator too (JBV, found by DD) */
+   while(( expression[ e_pos ] != '\"') && ( expression[ e_pos ] != '\0' ))
       {
       CURTASK exps[ CURTASK expsc ].string[ s_pos ] = expression[ e_pos ];
       ++e_pos;
@@ -219,7 +228,11 @@ exp_strconst( expression )
 
    /* advance past last double quotation mark */
 
-   ++CURTASK exps[ CURTASK expsc ].pos_adv;
+   /*-------------------------------------------------------------*/
+   /* Of course, it doesn't hurt to make sure it's really a quote */
+   /* (JBV, found by DD)                                          */
+   /*-------------------------------------------------------------*/
+   if ( expression[ e_pos ] == '\"' ) ++CURTASK exps[ CURTASK expsc ].pos_adv;
 
    /* return */
 
@@ -654,6 +667,8 @@ exp_numconst( expression )
                case 'd':
                case 'E':
                case 'e':
+               case 'F': /* Don't forget these! (JBV) */
+               case 'f':
                   CURTASK exps[ CURTASK expsc ].string[ s_pos ] = expression[ CURTASK exps[ CURTASK expsc ].pos_adv ];
 
                   ++CURTASK exps[ CURTASK expsc ].pos_adv;  /* advance to next character */
@@ -718,7 +733,8 @@ exp_function( expression )
    int paren_level;
    int n_args;
    struct bwb_variable *v;
-   struct bwb_variable argv[ MAX_FARGS ];
+   /* struct bwb_variable argv[ MAX_FARGS ]; */ /* Removed by JBV */
+   struct bwb_variable *argv; /* Added by JBV */
    bstring *b;
 #if INTENSIVE_DEBUG
    char tbuf[ MAXSTRINGSIZE + 1 ];
@@ -728,6 +744,18 @@ exp_function( expression )
    bwb_debug( bwb_ebuf );
 #endif
 
+   /*-----------------------------------------------------------*/
+   /* Added by JBV                                              */
+   /* Required because adding a simple "static" modifier in the */
+   /* argv declaration doesn't work for recursive calls!        */
+   /*-----------------------------------------------------------*/
+   if ( ( argv = (struct bwb_variable *) CALLOC( MAX_FARGS,
+      sizeof( struct bwb_variable ), "exp_function" )) == NULL )
+      {
+      bwb_error( err_getmem );
+      return NULL;
+      }
+
    /* assign pointers to argument stack */
 
    /* get the function name */
@@ -1014,6 +1042,13 @@ exp_function( expression )
    v = CURTASK exps[ CURTASK expsc ].function->vector ( n_args, &( argv[ 0 ] ),
       CURTASK exps[ CURTASK expsc ].function->id );
 
+   /*-------------------------------------------------*/
+   /* Now free the argv memory                        */
+   /* (some other less fortunate routine may need it) */
+   /* JBV, 10/95                                      */
+   /*-------------------------------------------------*/
+   FREE( argv, "exp_function" );
+
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in exp_function(): return from function vector, type <%c>",
       v->type );
@@ -1117,7 +1152,7 @@ exp_variable( expression )
       {
 #if INTENSIVE_DEBUG
       sprintf( bwb_ebuf, "in exp_variable(): variable <%s> has 1 dimension",
-	 CURTASK exps[ CURTASK expsc ].xvar->name );
+         CURTASK exps[ CURTASK expsc ].xvar->name );
       bwb_debug( bwb_ebuf );
 #endif
       pos = strlen( v->name );
@@ -1128,10 +1163,8 @@ exp_variable( expression )
    else
       {
 #if INTENSIVE_DEBUG
-      sprintf( bwb_ebuf, "in exp_variable(): level <%d> variable <%s> has <%d> dimensions",
-	 CURTASK expsc,
-	 v->name,
-	 v->dimensions );
+      sprintf( bwb_ebuf, "in exp_variable(): variable <%s> has > 1 dimensions",
+         CURTASK exps[ CURTASK expsc ].xvar->name );
       bwb_debug( bwb_ebuf );
 #endif
       dim_getparams( expression, &pos, &n_params, &pp );
@@ -1144,25 +1177,18 @@ exp_variable( expression )
       }
 
 #if INTENSIVE_DEBUG
-   if ( v->dimensions > 1 )
+   for ( n = 0; n < v->dimensions; ++ n )
       {
-      sprintf( bwb_ebuf, "in exp_variable(): exec stack level <%d>",
-	 CURTASK exsc );
+      sprintf( bwb_ebuf, "in exp_variable(): var <%s> array_pos element <%d> is <%d>.",
+         v->name, n, v->array_pos[ n ] );
       bwb_debug( bwb_ebuf );
-      for ( n = 0; n < v->dimensions; ++n )
-	 {
-	 sprintf( bwb_ebuf, "   variable <%s> array_pos element <%d> is <%d>.",
-	    v->name, n, v->array_pos[ n ] );
-	 bwb_debug( bwb_ebuf );
-	 }
       }
 #endif
 
    /* assign the type and value at this level */
 
    CURTASK exps[ CURTASK expsc ].type = (char) v->type;
-   CURTASK exps[ CURTASK expsc ].xvar = v;
-
+   
    switch( v->type )
       {
       case STRING:
@@ -1180,7 +1206,7 @@ exp_variable( expression )
          break;
       default:
          CURTASK exps[ CURTASK expsc ].nval = var_getnval( v );
-	 break;
+         break;
       }
 
 #if INTENSIVE_DEBUG
diff --git a/bwb_exp.c b/bwb_exp.c
index 1381d77..f8e5724 100644
--- a/bwb_exp.c
+++ b/bwb_exp.c
@@ -23,6 +23,11 @@
 
 ****************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <ctype.h>
 #include <math.h>
@@ -71,7 +76,7 @@ bwb_exp( expression, assignment, position )
    entry_level = CURTASK expsc;
    err_condition = FALSE;
 
-   /* advance past whitespace or beginningg of line segment */
+   /* advance past whitespace or beginning of line segment */
 
 #if MULTISEG_LINES
    if ( expression[ *position ] == ':' )
@@ -192,6 +197,7 @@ bwb_exp( expression, assignment, position )
          case OP_XOR:
          case OP_IMPLIES:
          case OP_EQUIV:
+         case OP_NEGATION: /* JBV */
 
 #if INTENSIVE_DEBUG
             sprintf( bwb_ebuf, "in bwb_exp(): operator detected." );
@@ -595,7 +601,7 @@ exp_findop( expression )
       {
 
 #if INTENSIVE_DEBUG
-      sprintf( bwb_ebuf, "in bwb_findop() loop position <%d> char 0x%x",
+      sprintf( bwb_ebuf, "in exp_findop() loop position <%d> char 0x%x",
 	 c, expression[ position ] );
       bwb_debug( bwb_ebuf );
 #endif
@@ -692,8 +698,8 @@ exp_findop( expression )
 	FUNCTION:       exp_isnc()
 
 	DESCRIPTION:    This function reads the expression to find
-			if a logical or mathematical operation is
-			required at this point.
+			if a numerical constant is present at this
+			point.
 
 ***************************************************************/
 
@@ -706,6 +712,7 @@ exp_isnc( expression )
    char *expression;
 #endif
    {
+   char tbuf[ MAXVARNAMESIZE + 1 ]; /* JBV */
 
    switch( expression[ 0 ] )
       {
@@ -752,6 +759,20 @@ exp_isnc( expression )
             return OP_NULL;
             }
 
+         /*--------------------------------------------------------*/
+         /* Check for unary minus sign added by JBV.               */
+         /* Could be prefixing a parenthetical expression or a     */
+         /* variable name.                                         */
+         /* But parentheses won't show up in expression (cbuf), so */
+         /* just check for expression and variable name lengths.   */
+         /*--------------------------------------------------------*/
+         if (expression[0] == '-')
+         {
+             if (strlen(expression) == 1) return OP_NEGATION;
+             exp_getvfname(&expression[1], tbuf);
+             if (strlen(tbuf) != 0) return OP_NEGATION;
+         }
+
          /* failing these tests, the argument must be a numerical
             constant preceded by a plus or minus sign */
 
@@ -1112,7 +1133,7 @@ exp_getvfname( source, destination )
    while( source[ s_pos ] != '\0' )
       {
 
-      /* all aphabetical characters are acceptable */
+      /* all alphabetical characters are acceptable */
 
       if ( isalpha( source[ s_pos ] ) != 0 )
 
diff --git a/bwb_fnc.c b/bwb_fnc.c
index 50270ea..3a1dc19 100644
--- a/bwb_fnc.c
+++ b/bwb_fnc.c
@@ -24,6 +24,11 @@
 
 ****************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #define FSTACKSIZE      32
 
 #include <stdio.h>
@@ -130,7 +135,9 @@ fnc_find( buffer )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_find" )) == NULL )
          {
 #if PROG_ERRORS
 	 bwb_error( "in fnc_find(): failed to find memory for tbuf" );
@@ -314,7 +321,9 @@ fnc_date( argc, argv, unique_id )
       {
       init = TRUE;
       var_make( &nvar, STRING );
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_date" )) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in fnc_date(): failed to get memory for tbuf" );
@@ -368,7 +377,9 @@ fnc_time( argc, argv, unique_id )
       {
       init = TRUE;
       var_make( &nvar, STRING );
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_time" )) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in fnc_time(): failed to get memory for tbuf" );
@@ -516,7 +527,9 @@ fnc_len( argc, argv, unique_id )
       {
       init = TRUE;
       var_make( &nvar, NUMBER );
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_len" )) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in fnc_len(): failed to get memory for tbuf" );
@@ -637,8 +650,9 @@ fnc_timer( argc, argv, unique_id  )
       }
 
    time( &now );
+   /* Following statement was (bnumber) (JBV) */
    * var_findnval( &nvar, nvar.array_pos )
-      = (float) fmod( (bnumber) now, (bnumber) (60*60*24));
+      = (float) fmod( (double) now, (double) (60*60*24));
 
    return &nvar;
    }
@@ -952,7 +966,9 @@ fnc_asc( argc, argv, unique_id )
       {
       init = TRUE;
       var_make( &nvar, NUMBER );
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_asc" )) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in fnc_asc(): failed to get memory for tbuf" );
@@ -1046,7 +1062,9 @@ fnc_string( argc, argv, unique_id )
       {
       init = TRUE;
       var_make( &nvar, STRING );
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_string" )) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in fnc_string(): failed to get memory for tbuf" );
@@ -1097,7 +1115,7 @@ fnc_string( argc, argv, unique_id )
 
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in fnc_string(): argument <%s> arg type <%c>, length <%d>",
-      argv[ 1 ].string, argv[ 1 ].type, length );
+      tbuf, argv[ 1 ].type, length );
    bwb_debug( bwb_ebuf );
    sprintf( bwb_ebuf, "in fnc_string(): type <%c>, c <0x%x>=<%c>",
       argv[ 1 ].type, c, c );
@@ -1320,7 +1338,9 @@ fnc_space( argc, argv, unique_id )
       {
       init = TRUE;
       var_make( &nvar, (int) STRING );
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_space" )) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in fnc_space(): failed to get memory for tbuf" );
@@ -1513,7 +1533,7 @@ fnc_erl( argc, argv, unique_id )
 
         DESCRIPTION:    This C function implements the BASIC
 			LOC() function. As implemented here,
-			this only workd for random-acess files.
+			this only works for random-acess files.
 
 	SYNTAX:		LOC( device-number )
 
@@ -1611,6 +1631,7 @@ fnc_eof( argc, argv, unique_id )
    static struct bwb_variable nvar;
    static int init = FALSE;
    int dev_number;
+   int cur_pos, end_pos; /* JBV */
 
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in fnc_loc(): received f_arg <%f> ",
@@ -1661,7 +1682,19 @@ fnc_eof( argc, argv, unique_id )
       bwb_error( err_devnum );
       * var_findnval( &nvar, nvar.array_pos ) = (bnumber) TRUE;
       }
-   else if ( feof( dev_table[ dev_number ].cfp ) == 0 )
+
+   /*------------------------------------------------------*/
+   /* feof() finds EOF when you read past the end of file. */
+   /* This is not how BASIC works, at least not GWBASIC.   */
+   /* The EOF function should return an EOF indication     */
+   /* when you are <at> the end of the file, not past it.  */
+   /* This routine was modified to reflect this.           */
+   /* (JBV, 10/15/95)                                      */
+   /*------------------------------------------------------*/
+
+   /*  else if ( feof( dev_table[ dev_number ].cfp ) == 0 ) */
+   else if ( ftell( dev_table[ dev_number ].cfp ) !=
+   dev_table [ dev_number ].lof )
       {
       * var_findnval( &nvar, nvar.array_pos ) = (bnumber) FALSE;
       }
@@ -1698,10 +1731,12 @@ fnc_lof( argc, argv, unique_id )
    static struct bwb_variable nvar;
    static int init = FALSE;
    int dev_number;
-#if UNIX_CMDS
+
+/* Following section no longer needed, removed by JBV */
+/* #if UNIX_CMDS
    static struct stat statbuf;
    int r;
-#endif
+#endif */
 
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in fnc_lof(): received f_arg <%f> ",
@@ -1742,7 +1777,8 @@ fnc_lof( argc, argv, unique_id )
 
    /* stat the file */
 
-#if UNIX_CMDS
+/* Following section no longer needed, removed by JBV */
+/* #if UNIX_CMDS
 
    r = stat( dev_table[ dev_number ].filename, &statbuf );
 
@@ -1760,13 +1796,15 @@ fnc_lof( argc, argv, unique_id )
       return NULL;
       }
 
-   * var_findnval( &nvar, nvar.array_pos ) = (bnumber) statbuf.st_size;
+   * var_findnval( &nvar, nvar.array_pos ) = (bnumber) statbuf.st_size; */
 
-#else
+/* #else */  /* Removed by JBV, no longer needed */
 
-   * var_findnval( &nvar, nvar.array_pos ) = (bnumber) FALSE;
+   /* * var_findnval( &nvar, nvar.array_pos ) = (bnumber) FALSE; */
+   * var_findnval( &nvar, nvar.array_pos ) =
+      (bnumber) dev_table[ dev_number ].lof; /* JBV */
 
-#endif
+/* #endif */  /* Removed by JBV, no longer needed */
 
    return &nvar;
    }
@@ -1806,7 +1844,9 @@ fnc_test( argc, argv, unique_id )
       {
       init = TRUE;
       var_make( &rvar, NUMBER );
-      if ( ( tbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "fnc_test" )) == NULL )
          {
 #if PROG_ERRORS
          bwb_error( "in fnc_test(): failed to get memory for tbuf" );
